// Finisher.h

//Copyright (C) 2001 by Guido Fioretti, via Angeloni 11, I - 05100 Terni. This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

#import <objectbase/SwarmObject.h>
#import <space.h>
#import <gui.h>




@interface Finisher: SwarmObject

{
  int xPos, yPos;
  int xPosEast, xPosWest;
  int yPosNorth, yPosSouth;
  int xPosEastEast, xPosWestWest;
  int yPosNorthNorth, yPosSouthSouth;
  int identity;
  int worldXSize, worldYSize;

  int workInProgress;
  int workingState[5];

  id <Grid2d> world;
  id modelSwarm;

  id eastOfFinisher;
  id northOfFinisher;
  id westOfFinisher;
  id southOfFinisher;

  id eastEastOfFinisher;
  id northNorthOfFinisher;
  id westWestOfFinisher;
  id southSouthOfFinisher;

  id northEastOfFinisher;
  id northWestOfFinisher;
  id southWestOfFinisher;
  id southEastOfFinisher;
}


- setX: (int)x Y: (int)y;
- (int)getXPos;
- (int)getYPos;
- (int)getXPosEast;
- (int)getXPosWest;
- (int)getYPosNorth;
- (int)getYPosSouth;

- setIdentity: (int)ID;
- (int)getIdentity;

- setWorld: W;
- setModelSwarm: MS;
- createEnd;

- (int)whoAreYou;
- (int)doYouHaveFreeSpaceAround;
- (int)doYouHaveFreeSpaceEast;
- (int)doYouHaveFreeSpaceNorth;
- (int)doYouHaveFreeSpaceWest;
- (int)doYouHaveFreeSpaceSouth;

- setWorkInProgress: (int)wp;
- (int *)areYouWorking;

- step;
- drawSelfOn: (id <Raster>)R;


@end














