// Middleman.h

//Copyright (C) 2001 by Guido Fioretti, via Angeloni 11, I - 05100 Terni. This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

#import <objectbase/SwarmObject.h>
#import <space.h>
#import <gui.h>




@interface Middleman: SwarmObject

{
  int xPos, yPos;
  int xPosEast, xPosWest;
  int yPosNorth, yPosSouth;
  int xPosEastEast, xPosWestWest;
  int yPosNorthNorth, yPosSouthSouth;
  int identity;
  int worldXSize, worldYSize;

  int workInProgressEast;
  int workInProgressNorth;
  int workInProgressWest;
  int workInProgressSouth;
  int workingState[5];
  
  struct resultOfAddFirm
  {
    int name;
    id pointer;
    int direction;
  } firmAdded;
  
  struct resultOfFindAround
  {
    int name;
    id pointer;
  } firmFoundAround;

  id <Grid2d> world;
  id modelSwarm;
  id observerSwarm;

  id employedFirmsList;
  id employedFirm;
  int employedFirmIs;
  int employedFirmsName;
}


- setX: (int)x Y: (int)y;
- (int)getXPos;
- (int)getYPos;
- (int)getXPosEast;
- (int)getXPosWest;
- (int)getYPosNorth;
- (int)getYPosSouth;

- setIdentity: (int)ID;
- (int)getIdentity;

- setWorld: W;
- setModelSwarm: MS;
- setObserverSwarm: OS;
- buildObjects;
- createEnd;

- (int)whoAreYou;
- (int)doYouHaveFreeSpaceAround;
- (int)doYouHaveFreeSpaceEast;
- (int)doYouHaveFreeSpaceNorth;
- (int)doYouHaveFreeSpaceWest;
- (int)doYouHaveFreeSpaceSouth;

- setWorkInProgress: (int)wp AtSide: (int)s;
- (int *)areYouWorking;

- step;

- (struct resultOfAddFirm)addFirmEast: (int)Firm1 Or: (int)Firm2 Or: (int)Firm3 StartingFrom: (id)lastLink;
- (struct resultOfAddFirm)addFirmNorth: (int)Firm1 Or: (int)Firm2 Or: (int)Firm3 StartingFrom: (id)lastLink;
- (struct resultOfAddFirm)addFirmWest: (int)Firm1 Or: (int)Firm2 Or: (int)Firm3 StartingFrom: (id)lastLink;
- (struct resultOfAddFirm)addFirmSouth: (int)Firm1 Or: (int)Firm2 Or: (int)Firm3 StartingFrom: (id)lastLink;
- (struct resultOfFindAround)findAroundWho1: (int)whoYouWant1 Who2: (int)whoYouWant2 Who3: (int)whoYouWant3 WhereX: (int)xDistance WhereY: (int)yDistance;

- drawSelfOn: (id <Raster>)R;
- dropObjects;


@end














