// ModelSwarm.h

//Copyright (C) 2001 by Guido Fioretti, via Angeloni 11, I - 05100 Terni. This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

#import "TraderRawMaterials.h"
#import "RagsCollector.h"
#import "CarderSpinning.h"
#import "ComberSpinning.h"
#import "Warper.h"
#import "Weaver.h"
#import "DyeingPlant.h"
#import "Finisher.h"
#import "Middleman.h"
#import "TraderFinishedProducts.h"

#import <objectbase/Swarm.h>
#import <space.h>
#import <simtools.h>
#import <stdlib.h>  






@interface ModelSwarm: Swarm



{
  int iTRM, iRC, iCaS, iCoS, iWa, iWe, iDP, iF, iTFP, iM, j;
  int traderRawMaterialsNumber, traderRawMaterialsOldNumber;
  int ragsCollectorNumber, ragsCollectorOldNumber;
  int carderSpinningNumber, carderSpinningOldNumber;
  int comberSpinningNumber, comberSpinningOldNumber;
  int warperNumber, warperOldNumber;
  int weaverNumber, weaverOldNumber;
  int dyeingPlantNumber, dyeingPlantOldNumber;
  int finisherNumber, finisherOldNumber;
  int traderFinishedProductsNumber, traderFinishedProductsOldNumber;
  int middlemanNumber, middlemanOldNumber;
  int totalFirmsNumber;

  int modelScale;
  int worldXSize;
  int worldYSize;
  int stepsInAYear;
  int xWatchRange;
  int yWatchRange;
  float variance;

  int stepCounter;
  int yearCounter;

  int p, q;
  int bookedPositions[1000][1000];


  TraderRawMaterials *aTraderRawMaterials;
  RagsCollector *aRagsCollector;
  CarderSpinning *aCarderSpinning;
  ComberSpinning *aComberSpinning;
  Warper *aWarper;
  Weaver *aWeaver;
  DyeingPlant *aDyeingPlant;
  Finisher *aFinisher;
  TraderFinishedProducts *aTraderFinishedProducts;
  Middleman *aMiddleman;


  id traderRawMaterialsList;
  id ragsCollectorList;
  id carderSpinningList;
  id comberSpinningList;
  id warperList;
  id weaverList;
  id dyeingPlantList;
  id finisherList;
  id traderFinishedProductsList;
  id middlemanList;

  id <InFile> inputMatrix;
  id observerSwarm;
  id <Grid2d> world;
  id modelActions;
  id modelSchedule;
  id <ListShuffler> shuffler;
}


- importFirmsNumber: (int)year;
- setObserverSwarm: OS;
- getWorld;

- getTraderRawMaterialsList;
- getRagsCollectorList;
- getCarderSpinningList;
- getComberSpinningList;
- getWarperList;
- getWeaverList;
- getDyeingPlantList;
- getFinisherList;
- getTraderFinishedProductsList;
- getMiddlemanList;

+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;
- firmsCreateAndDestroy;

- bookX: (int)x Y: (int)y;
- (int)isBookedX: (int)x Y: (int)y;
- clearBookedPositions;




@end


















