// ObserverSwarm.h

//Copyright (C) 2001 by Guido Fioretti, via Angeloni 11, I - 05100 Terni. This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

#import "ModelSwarm.h"
#import "Middleman.h"
#import <simtoolsgui/GUISwarm.h>
#include <stdio.h>

@interface ObserverSwarm: GUISwarm
{
  int rasterXSize, rasterYSize;
  int zoomFactor;
  int displayFrequency;                          
  int theEnd;

  int stepCounter;
  int oldStepCounter;
  int yearCounter;
  int oldYearCounter;
  int stepsInThisYear;
  int stepsInTheNextYear;

  int chain9865371Counter;
  int chain98653721Counter;
  int chain9865471Counter;
  int chain986571Counter;
  int chain9865731Counter;
  int chain98657321Counter;
  int chain9865741Counter;
  int chain987651Counter;
  int chain9876531Counter;
  int chain98765321Counter;
  int chain9876541Counter;
  int anyChainDuringOneStepCounter;
  int anyChainDuringOneYearCounter;
  int anyChainInTheBufferCounter;

  int chain9865371Parallelism;
  int chain98653721Parallelism;
  int chain9865471Parallelism;
  int chain986571Parallelism;
  int chain9865731Parallelism;
  int chain98657321Parallelism;
  int chain9865741Parallelism;
  int chain987651Parallelism;
  int chain9876531Parallelism;
  int chain98765321Parallelism;
  int chain9876541Parallelism;

  double degreeOfParallelism;
  double summedDegreeOfParallelism;
  double averagedDegreeOfParallelism;

  double degreeOfVariability;
  double summedDegreeOfVariability;
  double averagedDegreeOfVariability;

  int finisherPersistence;
  int summedFinisherPersistence;
  double degreeOfFinisherMobility;
  int weaverPersistence;
  int summedWeaverPersistence;
  double degreeOfWeaverMobility;

  int chainDuringOneStep[1000];
  int chainDuringOneStepOld[1000];
  int hookDuringOneStep[1000];
  int hookDuringOneStepOld[1000];
  int whichFinisherDuringOneYear[1000];
  int whichWeaverDuringOneYear[1000];
  int hookDuringOneYear[1000];

  ModelSwarm *modelSwarm;          		

  id displayActions;                             
  id displaySchedule;

  id <Colormap> colorMap;                        
  id <ZoomRaster> worldRaster;                  

  id <Object2dDisplay> traderRawMaterialsDisplay; 
  id <Object2dDisplay> ragsCollectorDisplay;
  id <Object2dDisplay> carderSpinningDisplay;
  id <Object2dDisplay> comberSpinningDisplay;
  id <Object2dDisplay> warperDisplay;
  id <Object2dDisplay> weaverDisplay;
  id <Object2dDisplay> dyeingPlantDisplay;
  id <Object2dDisplay> finisherDisplay;
  id <Object2dDisplay> middlemanDisplay;
  id <Object2dDisplay> traderFinishedProductsDisplay;

  id <Graph> firstGraph;
  id <GraphElement> parallelismElement;
  id <GraphElement> variabilityElement;

  id <Graph> secondGraph;
  id <GraphElement> finisherMobilityElement;
  id <GraphElement> weaverMobilityElement;

  id <OutFile> outputMatrix;
  id <OutFile> outputVariabilityVector;
  id <OutFile> outputParallelismVector;
  id <OutFile> outputFinisherMobilityVector;
  id <OutFile> outputWeaverMobilityVector;
}


+ createBegin: aZone;
- createEnd;
- setRasterXSize: (int)worldXSize;
- setRasterYSize: (int)worldYSize;

- buildObjects;
- paintBlack;
- yearInTheTitle: (int)year;

- setStepCounter: (int)step;
- setYearCounter: (int)year;
- setStepsInAYear: (int)length;

- communicateChain: (int)chain HangingFrom: (int)hook Including: (int)whichFinisher And: (int)whichWeaver;
- drawCurves;

- buildActions;
- activateIn: swarmContext;

- end;
- stop;


@end





