// TraderFinishedProducts.h

//Copyright (C) 2001 by Guido Fioretti, via Angeloni 11, I - 05100 Terni. This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

#import <objectbase/SwarmObject.h>
#import <space.h>
#import <gui.h>
#import <random.h>




@interface TraderFinishedProducts: SwarmObject

{
  int xWatchRange;
  int yWatchRange;
  float variance;

  int xPos, yPos;
  int xPosEast, xPosWest;
  int yPosNorth, yPosSouth;
  int xPosEastEast, xPosWestWest;
  int yPosNorthNorth, yPosSouthSouth;
  int identity;
  int worldXSize, worldYSize;

  int workInProgress;
  int workingState[5];
  int direction;

  id <Grid2d> world;
  id <NormalDist> myNormalDist;
  id modelSwarm;

  id eastOfTraderFinishedProducts;
  id northOfTraderFinishedProducts;
  id westOfTraderFinishedProducts;
  id southOfTraderFinishedProducts;

  id eastEastOfTraderFinishedProducts;
  id northNorthOfTraderFinishedProducts;
  id westWestOfTraderFinishedProducts;
  id southSouthOfTraderFinishedProducts;

  id northEastOfTraderFinishedProducts;
  id northWestOfTraderFinishedProducts;
  id southWestOfTraderFinishedProducts;
  id southEastOfTraderFinishedProducts;
}


- setX: (int)x Y: (int)y;
- (int)getXPos;
- (int)getYPos;
- (int)getXPosEast;
- (int)getXPosWest;
- (int)getYPosNorth;
- (int)getYPosSouth;

- setXwatchRange: (int)XWR;
- setYwatchRange: (int)YWR;
- setVariance: (float)V;

- setIdentity: (int)ID;
- (int)getIdentity;

- setWorld: W;
- setModelSwarm: MS;
- buildObjects;
- createEnd;

- (int)whoAreYou;
- (int)doYouHaveFreeSpaceAround;
- (int)doYouHaveFreeSpaceEast;
- (int)doYouHaveFreeSpaceNorth;
- (int)doYouHaveFreeSpaceWest;
- (int)doYouHaveFreeSpaceSouth;

- setWorkInProgress: (int)wp;
- (int *)areYouWorking;

- step;
- drawSelfOn: (id <Raster>)R;
- dropObjects;


@end














