// TraderFinishedProducts.m

//Copyright (C) 2001 by Guido Fioretti, via Angeloni 11, I - 05100 Terni. This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

#import "TraderFinishedProducts.h"
#import "ModelSwarm.h"






@implementation TraderFinishedProducts




// This method is used by ModelSwarm to initialize a TraderFinishedProducts's position, as well as by Middleman to move it into a production chain. Global variables xPosEast, xPosWest, yPosNorth, yPosSouth, xPosEastEast, yPosNorth, xPosWest and yPosSouth are initialized here, as well as global addresses eastOfTraderFinishedProducts, northOfTraderFinishedProducts, westOfTraderFinishedProducts, southOfTraderFinishedProducts, eastEastOfTraderFinishedProducts, northNorthOfTraderFinishedProducts, westWestOfTraderFinishedProducts, southSouthOfTraderFinishedProducts, northEastOfTraderFinishedProducts, northWestOfTraderFinishedProducts, southWestOfTraderFinishedProducts and southEastOfTraderFinishedProducts.

- setX: (int)x Y: (int)y
{
  xPos = x;
  yPos = y;

  xPosEast = (xPos + 1 + worldXSize) % worldXSize;
  yPosNorth = (yPos + 1 + worldYSize) % worldYSize;
  xPosWest = (xPos - 1 + worldXSize) % worldXSize;
  yPosSouth = (yPos - 1 + worldYSize) % worldYSize;
  
  xPosEastEast = (xPosEast + 1 + worldXSize) % worldXSize;
  yPosNorthNorth = (yPosNorth + 1 + worldYSize) % worldYSize;
  xPosWestWest = (xPosWest - 1 + worldXSize) % worldXSize;
  yPosSouthSouth = (yPosSouth - 1 + worldYSize) % worldYSize;

  eastOfTraderFinishedProducts = [world getObjectAtX: xPosEast Y: yPos];
  northOfTraderFinishedProducts = [world getObjectAtX: xPos Y: yPosNorth];
  westOfTraderFinishedProducts = [world getObjectAtX: xPosWest Y: yPos];
  southOfTraderFinishedProducts = [world getObjectAtX: xPos Y: yPosSouth];

  eastEastOfTraderFinishedProducts = [world getObjectAtX: xPosEastEast Y: yPos];
  northNorthOfTraderFinishedProducts = [world getObjectAtX: xPos Y: yPosNorthNorth];
  westWestOfTraderFinishedProducts = [world getObjectAtX: xPosWestWest Y: yPos];
  southSouthOfTraderFinishedProducts = [world getObjectAtX: xPos Y: yPosSouthSouth];

  northEastOfTraderFinishedProducts = [world getObjectAtX: xPosEast Y: yPosNorth];
  northWestOfTraderFinishedProducts = [world getObjectAtX: xPosWest Y: yPosNorth];
  southWestOfTraderFinishedProducts = [world getObjectAtX: xPosWest Y: yPosSouth];
  southEastOfTraderFinishedProducts = [world getObjectAtX: xPosEast Y: yPosSouth];
  
  return self;
}




// These methods make xPos, yPos, xPosEast, xPosWest, yPosNorth and yPosSouth available to other firms.

- (int)getXPos
{
  return xPos;
}

- (int)getYPos
{
  return yPos;
}

- (int)getXPosEast
{
  return xPosEast;
}

- (int)getXPosWest
{
  return xPosWest;
}

- (int)getYPosNorth
{
  return yPosNorth;
}

- (int)getYPosSouth
{
  return yPosSouth;
}




// This method enables ModelSwarm to give an identity to each instance of TraderFinishedProducts that it creates.

- setIdentity: (int)ID
{
  identity = ID;
  return self;
}




// This method allows Middleman to ask TraderFinishedProducts about its identity.

- (int)getIdentity
{
  return identity;
}




// This method enables ModelSwarm to make the grid visible to TraderFinishedProducts. As soon as the grid is visible, TraderFinishedProducts imports its size.

- setWorld: W
{
  world = W;

  worldXSize = [world getSizeX];
  worldYSize = [world getSizeY];
  
  return self;
}




// This method enables TraderFinishedProducts to see ModelSwarm. In this way, it can ask ModelSwarm for the positions where production chains are, and not jump into them.  In order to avoid cross-references, ModelSwarm.h is imported in TraderFinishedProducts.m. This method is activated by -firmsCreateAndDestroy of ModelSwarm.

- setModelSwarm: MS
{
  modelSwarm = MS;
  return self;
}




// These methods enable ModelSwarm to communicate to TraderFinishedProducts the range where they are able to detect Middleman, as well as the variance of the distribution that regulates TraderFinishedProducts' random walk.

- setXwatchRange: (int)XWR
{
  xWatchRange = XWR;
  return self;
}

- setYwatchRange: (int)YWR
{
  yWatchRange = YWR;
  return self;
}

- setVariance: (float)V
{
  variance = V;
  return self;
}




// This method creates the Gaussian random numbers generator used by TraderFinishedProducts to jump.

- buildObjects
{
  myNormalDist = [NormalDist createWithDefaults: [self getZone]];
  return self;
}    




// This method ends the creation of TraderFinishedProducts. It can be used to initialize global variables. Among these, the direction by which TraderFinishedProducts approach Middleman.

- createEnd
{
  [super createEnd];
  
  workInProgress = 0;
  direction = [uniformIntRand getIntegerWithMin: 1 withMax: 4];

  return self;
}




// When asked who they are, TraderFinishedProducts answer "9".

- (int)whoAreYou
{
  return 9;
}




// These methods say whether the positions surrounding TraderFinishedProducts are free.  Method -doYouHaveSpaceAround returns 1 if at least one out of the four positions surrounding TraderFinishedProducts is free and it is surrounded by free positions, 0 otherwise. Method -doYouHaveFreeSpaceEast returns 1 if the position east of TraderFinishedProducts as well as the three positions that surround it are free, 0 otherwise. Methods -doYouHaveFreeSpaceNorth, -doYouHaveFreeSpaceWest and -doYouHaveFreeSpaceSouth behave similarly.

- (int)doYouHaveFreeSpaceAround
{
  int freeSpaceAround;

  if (((eastOfTraderFinishedProducts == nil) && (southEastOfTraderFinishedProducts == nil) && (eastEastOfTraderFinishedProducts == nil) && (northEastOfTraderFinishedProducts == nil)) || ((northOfTraderFinishedProducts == nil) && (northEastOfTraderFinishedProducts == nil) && (northNorthOfTraderFinishedProducts == nil) && (northWestOfTraderFinishedProducts == nil)) || ((westOfTraderFinishedProducts == nil) && (southWestOfTraderFinishedProducts == nil) && (westWestOfTraderFinishedProducts == nil) && (northWestOfTraderFinishedProducts == nil)) || ((southOfTraderFinishedProducts == nil) && (southWestOfTraderFinishedProducts == nil) && (southSouthOfTraderFinishedProducts == nil) && (southEastOfTraderFinishedProducts == nil)))
    freeSpaceAround = 1;
  else
    freeSpaceAround = 0;

  return freeSpaceAround;
}

- (int)doYouHaveFreeSpaceEast
{
  int freeSpaceEast;

  if ((eastOfTraderFinishedProducts == nil) && (southEastOfTraderFinishedProducts == nil) && (eastEastOfTraderFinishedProducts == nil) && (northEastOfTraderFinishedProducts == nil))
    freeSpaceEast = 1;
  else
    freeSpaceEast = 0;
  
  return freeSpaceEast;
}

- (int)doYouHaveFreeSpaceNorth
{
  int freeSpaceNorth;

  if ((northOfTraderFinishedProducts == nil) && (northEastOfTraderFinishedProducts == nil) && (northNorthOfTraderFinishedProducts == nil) && (northWestOfTraderFinishedProducts == nil))
    freeSpaceNorth = 1;
  else
    freeSpaceNorth = 0;
  
  return freeSpaceNorth;
}

- (int)doYouHaveFreeSpaceWest
{
  int freeSpaceWest;

  if ((westOfTraderFinishedProducts == nil) && (northWestOfTraderFinishedProducts == nil) && (westWestOfTraderFinishedProducts == nil) && (southWestOfTraderFinishedProducts == nil))
    freeSpaceWest = 1;
  else
    freeSpaceWest = 0;
  
  return freeSpaceWest;
}

- (int)doYouHaveFreeSpaceSouth
{
  int freeSpaceSouth;

  if ((southOfTraderFinishedProducts == nil) && (southWestOfTraderFinishedProducts == nil) && (southSouthOfTraderFinishedProducts == nil) && (southEastOfTraderFinishedProducts == nil))
    freeSpaceSouth = 1;
  else
    freeSpaceSouth = 0;
  
  return freeSpaceSouth;
}




// This method allows TraderFinishedProducts to receive the values of workInProgress that other firms may want to communicate. In -createEnd the variable "workInProgress" is initialized to 0.

- setWorkInProgress: (int)wp
{
  workInProgress = wp;
  return self;
}




// This method allows TraderFinishedProducts to tell other firms whether it is working. This information is carried by the 0-th component of the workingState vector. The other components are only used by the -areYouWorking method of Middleman.

- (int *)areYouWorking
{
  workingState[0] = workInProgress;
  workingState[1] = 0;
  workingState[2] = 0;
  workingState[3] = 0;
  workingState[4] = 0;

  return workingState;
}




// Firms are depicted on a torus.  In order to understand the "step" method, please remember that the raster draws positions in [0, (worldXSize - 1)] X [0, (worldYSize - 1)].  TraderFinishedProducts watch around the position they are in: if they find a Middleman they move close to it, otherwise they move according to a random walk according to a Gaussian distribution.  In order to exit the observation range of other firms, jumps are not shorter than 2 pixels. In order not to enter the observation range of other firms, TraderFinishedProducts only moves into a new position if its 12 nearest neighbors are free (east, north, west, south, northEast, northWest, southWest, southEast, eastEast, northNorth, westWest, southSouth). Unlike other moving firms, TraderFinishedProducts does not check whether the position it wants to move into is booked for constructing a production chain. 

- step
{
  int x, xMin1, xMin2, xMax1, xMax2;
  int y, yMin1, yMin2, yMax1, yMax2;

  id neighbor = nil;
  int neighborIs = 0;
  int IhaveFreeSpace;
  id freeSpacedMiddleman = nil;
  int freeSpacedMiddlemanIsThere = 0;

  double sample;
  int truncSample;
  int stepX, stepY;
  int xNewPos, yNewPos;
  int xNewPosEast = xPosEast;
  int yNewPosNorth = yPosNorth;
  int xNewPosWest = xPosWest;
  int yNewPosSouth = yPosSouth;
  int xNewPosEastEast = xNewPosEast;
  int yNewPosNorthNorth = yNewPosNorth;
  int xNewPosWestWest = xNewPosWest;
  int yNewPosSouthSouth = yNewPosSouth;
  id inNewPosition;
  id eastOfNewPosition;
  id northOfNewPosition;
  id westOfNewPosition;
  id southOfNewPosition;
  id northEastOfNewPosition;
  id northWestOfNewPosition;
  id southWestOfNewPosition;
  id southEastOfNewPosition;
  id eastEastOfNewPosition;
  id northNorthOfNewPosition;
  id westWestOfNewPosition;
  id southSouthOfNewPosition;
  int jumped = 0;

  int directionEastChecked = 0;
  int directionNorthChecked = 0;
  int directionWestChecked = 0;
  int directionSouthChecked = 0;

  if (workInProgress == 0)
    {
      // If it is not working, a TraderFinishedProducts makes a jump of lenght 2 or higher, according to a normal distribution. When TraderFinishedProducts is leaving a production chain, any shorter jump would keep it inside the range of the -doYouHaveFreeSpace method of the previous link of the chain.  Jumping is particularly important if TraderFinishedProducts was working during the previous time interval, because it gives the system some probability to modify its production chains. However, it is also important if TraderFinishedProducts was just jumping around, since in this way it can be captured by a different Middleman.

      while (jumped == 0)
	{
	  stepX = 0;
	  while ((stepX <= -worldXSize) || (stepX == -1) || (stepX == 0) || (stepX == 1) || (stepX >= worldXSize))
	    {
	      sample = [myNormalDist getSampleWithMean: 0.0 withVariance: variance];
	      truncSample = (int)sample;
	      if (sample <= (truncSample + 0.5))
		stepX = truncSample;
	      else if (sample > (truncSample + 0.5))
		{
		  if (truncSample > 0)
		    stepX = (truncSample + 1);
		  else if (truncSample < 0)
		    stepX = (truncSample - 1);
		}
	    }
	  xNewPos = xPos + stepX;

	  stepY = 0;
	  while ((stepY <= -worldYSize) || (stepY == -1) || (stepY == 0) || (stepY == 1) || (stepY >= worldYSize))
	    {
	      sample = [myNormalDist getSampleWithMean: 0.0 withVariance: 100.0];
	      truncSample = (int)sample;
	      if (sample <= (truncSample + 0.5))
		stepY = truncSample;
	      else if (sample > (truncSample + 0.5))
		{
		  if (truncSample > 0)
		    stepY = (truncSample + 1);
		  else if (truncSample < 0)
		    stepY = (truncSample - 1);
		}
	    }
	  yNewPos = yPos + stepY;
	  
	  
	  if (xNewPos < 0)
	    xNewPos = (xNewPos + worldXSize); 
	  else if (xNewPos >= worldXSize)
	    xNewPos = (xNewPos - worldXSize);
	  if (yNewPos < 0)
	    yNewPos = (yNewPos + worldYSize);
	  else if (yNewPos >= worldYSize)
	    yNewPos = (yNewPos - worldYSize);
	  
	  xNewPosEast = (xNewPos + 1 + worldXSize) % worldXSize;
	  yNewPosNorth = (yNewPos + 1 + worldYSize) % worldYSize;
	  xNewPosWest = (xNewPos - 1 + worldXSize) % worldXSize;
	  yNewPosSouth = (yNewPos - 1 + worldYSize) % worldYSize;      
	  xNewPosEastEast = (xNewPosEast + 1 + worldXSize) % worldXSize;
	  yNewPosNorthNorth = (yNewPosNorth + 1 + worldYSize) % worldYSize;
	  xNewPosWestWest = (xNewPosWest - 1 + worldXSize) % worldXSize;
	  yNewPosSouthSouth = (yNewPosSouth - 1 + worldYSize) % worldYSize;
	  
	  inNewPosition = [world getObjectAtX: xNewPos Y: yNewPos];
	  eastOfNewPosition = [world getObjectAtX: xNewPosEast Y: yNewPos];
	  northOfNewPosition = [world getObjectAtX: xNewPos Y: yNewPosNorth];
	  westOfNewPosition = [world getObjectAtX: xNewPosWest Y: yNewPos];
	  southOfNewPosition = [world getObjectAtX: xNewPos Y: yNewPosSouth];
	  northEastOfNewPosition = [world getObjectAtX: xNewPosEast Y: yNewPosNorth];
	  northWestOfNewPosition = [world getObjectAtX: xNewPosWest Y: yNewPosNorth];
	  southWestOfNewPosition = [world getObjectAtX: xNewPosWest Y: yNewPosSouth];
	  southEastOfNewPosition = [world getObjectAtX: xNewPosEast Y: yNewPosSouth];
	  eastEastOfNewPosition = [world getObjectAtX: xNewPosEastEast Y: yNewPos];
	  northNorthOfNewPosition = [world getObjectAtX: xNewPos Y: yNewPosNorthNorth];
	  westWestOfNewPosition = [world getObjectAtX: xNewPosWestWest Y: yNewPos];
	  southSouthOfNewPosition = [world getObjectAtX: xNewPos Y: yNewPosSouthSouth];
	  
	  if ((inNewPosition == nil) && (eastOfNewPosition == nil) && (northOfNewPosition == nil) && (westOfNewPosition == nil) && (southOfNewPosition == nil) && (northEastOfNewPosition == nil) && (northWestOfNewPosition == nil) && (southWestOfNewPosition == nil) && (southEastOfNewPosition == nil) && (eastEastOfNewPosition == nil) && (northNorthOfNewPosition == nil) && (westWestOfNewPosition == nil) && (southSouthOfNewPosition == nil))
	    {
	      [world putObject: nil atX: xPos Y: yPos];
	      xPos = xNewPos;
	      yPos = yNewPos;
	      [world putObject: self atX: xPos Y: yPos];
	      jumped = 1;
	    }
	  else
	    {
	      stepX = 0;
	      stepY = 0;
	    }
	  
	}
      
      
      // Subsequently, our TraderFinishedProducts sets out to explore its neighboring environment looking for a Middleman.  First of all, let us define the ranges where TraderFinishedProducts look for Middleman. This is not trivial, because our firms move on a torus. We define two lower and two upper bounds for x, two lower bounds and two upper bounds for y. Our ranges will be the cartesian products [xMin1, xMax1] X [yMin1, yMax1]; [xMin1, xMax1] X [yMin2, yMax2]; [xMin2, xMax2] X [yMin1, yMax1]; [xMin2, xMax2] X [yMin2, yMax2].
      
      if ((xPos - xWatchRange) < 0)
        {
	  xMin1 = 0;
	  xMax1 = (xPos + xWatchRange);
	  xMin2 = (worldXSize - 1) + (xPos - xWatchRange);
	  xMax2 = (worldXSize - 1);
	}
      else if ((xPos + xWatchRange) > (worldXSize - 1))
        {
	  xMin1 = (xPos - xWatchRange);
	  xMax1 = worldXSize - 1;
	  xMin2 = 0;
	  xMax2 = (xPos + xWatchRange) - (worldXSize - 1);
	}
      else
        {
	  xMin1 = (xPos - xWatchRange);
	  xMax1 = (xPos + xWatchRange);
	  xMin2 = xPos;
	  xMax2 = xPos;
	}
      if ((yPos - yWatchRange) < 0)
        {
	  yMin1 = 0;
	  yMax1 = (yPos + yWatchRange);
	  yMin2 = (worldYSize - 1) + (yPos - yWatchRange);
	  yMax2 = (worldYSize - 1);
	}
      else if ((yPos + yWatchRange) > (worldYSize - 1))
        {
	  yMin1 = (yPos - yWatchRange);
	  yMax1 = worldYSize - 1;
	  yMin2 = 0;
	  yMax2 = (yPos + yWatchRange) - (worldYSize - 1);
	}
      else
        {
	  yMin1 = (yPos - yWatchRange);
	  yMax1 = (yPos + yWatchRange);
	  yMin2 = yPos;
	  yMax2 = yPos;
	}
      

      // Now a TraderFinishedProducts examines its neighbors in order to find a Middleman. At each neighboring position it first checks that somebody is there; if yes, it asks who it is; if it is a Middleman, it asks whether at least one of its neighboring positions is free. If it is, it turns the variable freeSpacedMiddlemanIsThere into 1. This procedure is repeated 4 times, one for each of the above ranges.

      x = xMin1;
      while ((x <= xMax1) && (freeSpacedMiddlemanIsThere == 0))
	{
	  y = yMin1;
	  while ((y <= yMax1) && (freeSpacedMiddlemanIsThere == 0))
	    {
	      neighbor = [world getObjectAtX: x Y: y];
	      if (neighbor != nil)
		{
		  neighborIs = [neighbor whoAreYou];
		  if (neighborIs == 10)
		    {
		      IhaveFreeSpace = [neighbor doYouHaveFreeSpaceAround];
		      if (IhaveFreeSpace == 1)
			{
			  freeSpacedMiddlemanIsThere = 1;
			  freeSpacedMiddleman = neighbor;
			}
		    }
		}
	      y++;
	    }
	  x++;
	}
      x = xMin1;
      while ((x <= xMax1) && (freeSpacedMiddlemanIsThere == 0))
	{
	  y = yMin2;
	  while ((y <= yMax2) && (freeSpacedMiddlemanIsThere == 0))
	    {
	      neighbor = [world getObjectAtX: x Y: y];
	      if (neighbor != nil)
		{
		  neighborIs = [neighbor whoAreYou];
		  if (neighborIs == 10)
		    {
		      IhaveFreeSpace = [neighbor doYouHaveFreeSpaceAround];
		      if (IhaveFreeSpace == 1)
			{
			  freeSpacedMiddlemanIsThere = 1;
			  freeSpacedMiddleman = neighbor;
			}
		    }
		}
	      y++;
	    }
	  x++;
	}
      x = xMin2;
      while ((x <= xMax2) && (freeSpacedMiddlemanIsThere == 0))
	{
	  y = yMin1;
	  while ((y <= yMax1) && (freeSpacedMiddlemanIsThere == 0))
	    {
	      neighbor = [world getObjectAtX: x Y: y];
	      if (neighbor != nil)
		{
		  neighborIs = [neighbor whoAreYou];
		  if (neighborIs == 10)
		    {
		      IhaveFreeSpace = [neighbor doYouHaveFreeSpaceAround];
		      if (IhaveFreeSpace == 1)
			{
			  freeSpacedMiddlemanIsThere = 1;
			  freeSpacedMiddleman = neighbor;
			}
		    }
		}
	      y++;
	    }
	  x++;
	}
      x = xMin2;
      while ((x <= xMax2) && (freeSpacedMiddlemanIsThere == 0))
	{
	  y = yMin2;
	  while ((y <= yMax2) && (freeSpacedMiddlemanIsThere == 0))
	    {
	      neighbor = [world getObjectAtX: x Y: y];
	      if (neighbor != nil)
		{
		  neighborIs = [neighbor whoAreYou];
		  if (neighborIs == 10)
		    {
		      IhaveFreeSpace = [neighbor doYouHaveFreeSpaceAround];
		      if (IhaveFreeSpace == 1)
			{
			  freeSpacedMiddlemanIsThere = 1;
			  freeSpacedMiddleman = neighbor;
			}
		    }
		}
	      y++;
	    }
	  x++;
	}

      
      //Firstly, TraderFinishedProducts tries the side it occupied the last time: in this way, production chains have some stability.  If that side is not available, it selects at random one other side and settles down there. Then TraderFinishedProducts sets its own workInProgress variable to 1, calls the Middleman's -setX method in order to update eastOfMiddleman, northOfMiddleman, westOfMiddleman and northOfMiddleman, and calls the Middleman's -setWorkInProgress.
     
      if (freeSpacedMiddlemanIsThere == 1)
       	{
	  while ((directionEastChecked == 0)||(directionNorthChecked == 0)||(directionWestChecked == 0)||(directionSouthChecked == 0))
	    {
	      if ((direction == 1) && (directionEastChecked == 0))
		{
		  if (([freeSpacedMiddleman doYouHaveFreeSpaceEast] == 1) && ([freeSpacedMiddleman areYouWorking][1] == 0))
		    {
		      [world putObject: nil atX: xPos Y: yPos];
		      xPos = [freeSpacedMiddleman getXPosEast];
		      yPos = [freeSpacedMiddleman getYPos];
		      [world putObject: self atX: xPos Y: yPos];
		      [self setWorkInProgress: 1];
		      [freeSpacedMiddleman setWorkInProgress: 1 AtSide: 1];
		      direction = 1;
		      directionNorthChecked = 1;
		      directionWestChecked = 1;
		      directionSouthChecked = 1;
		    }
		  directionEastChecked = 1;
		}
	      else if ((direction == 2) && (directionNorthChecked == 0))
		{
		  if (([freeSpacedMiddleman doYouHaveFreeSpaceNorth] == 1) && ([freeSpacedMiddleman areYouWorking][2] == 0))
		    {
		      [world putObject: nil atX: xPos Y: yPos];
		      xPos = [freeSpacedMiddleman getXPos];
		      yPos = [freeSpacedMiddleman getYPosNorth];
		      [world putObject: self atX: xPos Y: yPos];
		      [self setWorkInProgress: 1];
		      [freeSpacedMiddleman setWorkInProgress: 1 AtSide: 2];
		      direction = 2;
		      directionEastChecked = 1;
		      directionWestChecked = 1;
		      directionSouthChecked = 1;
		    }
		  directionNorthChecked = 1;
		}
	      else if ((direction == 3) && (directionWestChecked == 0))
		{
		  if (([freeSpacedMiddleman doYouHaveFreeSpaceWest] == 1) && ([freeSpacedMiddleman areYouWorking][3] == 0))
		    {
		      [world putObject: nil atX: xPos Y: yPos];
		      xPos = [freeSpacedMiddleman getXPosWest];
		      yPos = [freeSpacedMiddleman getYPos];
		      [world putObject: self atX: xPos Y: yPos];
		      [self setWorkInProgress: 1];
		      [freeSpacedMiddleman setWorkInProgress: 1 AtSide: 3];
		      direction = 3;
		      directionEastChecked = 1;
		      directionNorthChecked = 1;
		      directionSouthChecked = 1;
		    }
		  directionWestChecked = 1;
		}
	      else if ((direction == 4) && (directionSouthChecked == 0))
		{
		  if (([freeSpacedMiddleman doYouHaveFreeSpaceSouth] == 1) && ([freeSpacedMiddleman areYouWorking][4] == 0))
		    {
		      [world putObject: nil atX: xPos Y: yPos];
		      xPos = [freeSpacedMiddleman getXPos];
		      yPos = [freeSpacedMiddleman getYPosSouth];
		      [world putObject: self atX: xPos Y: yPos];
		      [self setWorkInProgress: 1];
		      [freeSpacedMiddleman setWorkInProgress: 1 AtSide: 4];
		      direction = 4;
		      directionEastChecked = 1;
		      directionNorthChecked = 1;
		      directionWestChecked = 1;
		    }
		  directionSouthChecked = 1;
		}
	      else while ((((direction == 1) && (directionEastChecked == 1)) || ((direction == 2) && (directionNorthChecked == 1)) || ((direction == 3) && (directionWestChecked == 1)) || ((direction == 4) && (directionSouthChecked == 1))) && ((directionEastChecked == 0) || (directionNorthChecked == 0) || (directionWestChecked == 0) || (directionSouthChecked == 0)))
		direction = [uniformIntRand getIntegerWithMin: 1 withMax: 4];

	    }
	}
      
      
      // Since TraderFinishedProducts moved, global variables xPosEast, xPosWest, yPosNorth, yPosSouth, xPosEastEast, yPosNorthNorth, xPosWestWest and yPosSouthSouth must be updated.
      
      xPosEast = (xPos + 1 + worldXSize) % worldXSize;
      yPosNorth = (yPos + 1 + worldYSize) % worldYSize;
      xPosWest = (xPos - 1 + worldXSize) % worldXSize;
      yPosSouth = (yPos - 1 + worldYSize) % worldYSize;
      
      xPosEastEast = (xPosEast + 1 + worldXSize) % worldXSize;
      yPosNorthNorth = (yPosNorth + 1 + worldYSize) % worldYSize;
      xPosWestWest = (xPosWest - 1 + worldXSize) % worldXSize;
      yPosSouthSouth = (yPosSouth - 1 + worldYSize) % worldYSize;
   }
  

  // As long as a TraderFinishedProducts is working, it doesn't move from its position.   Unlike other moving firms, TraderFinishedProducts is able to set its workInProgress variable to 1 by itself.  This causes a problem when a Middleman is cancelled: though Middleman sends around a message to set the workInProgress variable to 0, and though TraderFinishedProducts propagates this message to neighboring firms, TraderFinishedProducts itself ends up with the workInProgress variable set to 1. Similarly, if Middleman is not able to find a Finisher to attach to TraderFinishedProducts, TraderFinishedProducts may be trapped aside Middleman.  Unlike other moving firms, the ensuing code entails a condition that keeps TraderFinishedProducts moving if at least three of its surrounding positions are free.

  else if (workInProgress == 1)
    {
      [world putObject: nil atX: xPos Y: yPos];
      [world putObject: self atX: xPos Y: yPos];

      if ((eastOfTraderFinishedProducts == nil) && (northOfTraderFinishedProducts == nil) && (southOfTraderFinishedProducts == nil))
	[self setWorkInProgress: 0];
      if ((eastOfTraderFinishedProducts == nil) && (northOfTraderFinishedProducts == nil) && (westOfTraderFinishedProducts == nil))
	[self setWorkInProgress: 0];
      if ((northOfTraderFinishedProducts == nil) && (westOfTraderFinishedProducts) && (southOfTraderFinishedProducts == nil))
	[self setWorkInProgress: 0];
      if ((westOfTraderFinishedProducts == nil) && (southOfTraderFinishedProducts == nil) && (eastOfTraderFinishedProducts == nil))
	[self setWorkInProgress: 0];
    }  


  // Whether TraderFinishedProducts moved or not, its neighbors might have changed and must be updated.

  eastOfTraderFinishedProducts = [world getObjectAtX: xPosEast Y: yPos];
  northOfTraderFinishedProducts = [world getObjectAtX: xPos Y: yPosNorth];
  westOfTraderFinishedProducts = [world getObjectAtX: xPosWest Y: yPos];
  southOfTraderFinishedProducts = [world getObjectAtX: xPos Y: yPosSouth];

  eastEastOfTraderFinishedProducts = [world getObjectAtX: xPosEastEast Y: yPos];
  northNorthOfTraderFinishedProducts = [world getObjectAtX: xPos Y: yPosNorthNorth];
  westWestOfTraderFinishedProducts = [world getObjectAtX: xPosWestWest Y: yPos];
  southSouthOfTraderFinishedProducts = [world getObjectAtX: xPos Y: yPosSouthSouth];

  northEastOfTraderFinishedProducts = [world getObjectAtX: xPosEast Y: yPosNorth];
  northWestOfTraderFinishedProducts = [world getObjectAtX: xPosWest Y: yPosNorth];
  southWestOfTraderFinishedProducts = [world getObjectAtX: xPosWest Y: yPosSouth];
  southEastOfTraderFinishedProducts = [world getObjectAtX: xPosEast Y: yPosSouth];
      

  return self;
}




// This method draws a TraderFinishedProducts on the raster.

- drawSelfOn: (id <Raster>)R
{
  [R drawPointX: xPos Y: yPos Color: 9];
  return self;
}




// This method drops the Gaussian random numbers generator created within TraderFinishedProducts. It is called by -firmsCreateAndDestroy of ModelSwarm.

- dropObjects
{
  [myNormalDist drop];
  return self;
}




@end



















